/* kbsimple.c -- very simple usage example of the libkb keyboard library
 * Copyright (C) 1995, 1996 Markus F.X.J. Oberhumer
 * For conditions of distribution and use, see copyright notice in kb.h 
 */


#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <kb.h>
#include "_kbintro.h"		/* _kb_intro_text() */


static int esc_pressed(void)
{
	if (kb_key(KB_SCAN_ESC))
	{
		if ((kb_key(KB_SCAN_LCONTROL) || kb_key(KB_SCAN_RCONTROL)) &&
			(kb_key(KB_SCAN_LSHIFT) || kb_key(KB_SCAN_RSHIFT)))
			return 1;
		if (kb_key(KB_SCAN_ALTGR))
			return 1;
	}
	return 0;
}


/***********************************************************************
// 
************************************************************************/

int main(int argc, char *argv[])
{
	int i;
	char s[80+1];

	printf("\n");
	_kb_intro_text(s);
	fputs(s,stdout);
	printf("\n\n");
	printf("Please send your bug reports, fixes, enhancements or suggestions to:\n");
	printf("Markus F.X.J. Oberhumer <markus.oberhumer@jk.uni-linz.ac.at>\n");
	printf("\n");

	if (!kb_install(0))
	{
		printf("Couldn't install keyboard interrupt !\n");
		exit(1);
	}

	printf("Keyboard interrupt installed.\n");
	printf("Hit any key to test, Ctrl-Shift-Esc or AltGr-Esc to quit\n\n");

	while (!esc_pressed())
	{
		int c = 0;

		while (KB_ANY_MASK(kb_shift(), KB_SHIFT_ANY_CONTROL) &&
			KB_ANY_MASK(kb_shift(), KB_SHIFT_ANY_ALT) &&
			(kb_key(KB_SCAN_DEL) || kb_key(KB_SCAN_COMMA_PAD)))
		{
			if (c == 0)
			{
				printf("Control-Alt-Del pressed\n");
				c++;
			}
		}

		if (kb_shift() & KB_SHIFT_CONTROL_BREAK)
		{
			printf("Control-Break pressed\n");
			_kb_shift &= ~(KB_SHIFT_CONTROL_BREAK);
		}

		if (kb_shift() & KB_SHIFT_PAUSE)
		{
			if (KB_ALL_MASK(kb_shift(), KB_SHIFT_ANY_CONTROL))
				printf("LControl-RControl-Break pressed\n");
			else
				printf("Pause pressed\n");
			_kb_shift &= ~(KB_SHIFT_PAUSE);
		}
	}

	printf("\n");
	printf("%d keys now pressed: ", kb_keys_pressed());
	for (i = 0; i < 128; i++)
		if (kb_key(i))
			printf("%02x ", i);
	printf("\n");
	fflush(stdout);

	return 0;
}


/*
vi:ts=4
*/
